//+------------------------------------------------------------------+
//|                          Parabolic SAR Color and Alerts v1.2.mq4 |
//|                                                       by Kalenzo |
//|                                       http://www.foreksik.prv.pl |
//|                                modified by http://ForexBaron.net |
//+------------------------------------------------------------------+
#property copyright "Kalenzo, modified by http://forexBaron.net"
#property link      "http://www.foreksik.prv.pl / http://forexbaron.net"

#property indicator_color1 Magenta
#property indicator_color2 Yellow
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_width1 2
#property indicator_width2 2

extern string note1 = "default settings: 0.02 / 0.2 / 7";
extern double Step = 0.02;
extern double Maximum = 0.2;
extern int Precision = 7;

extern string note2 = "Want to receive signals?";
extern string note3 = "set SignalsEnabled to true and then";
extern string note4 = "choose the kind of alerts you want";
extern string note5 = "(for SignalMail you have to set up";
extern string note6 = "SMTP at MT4-tools-options-email!)";
extern bool SignalsEnabled = true;
extern bool Alerts = False;
extern bool SignalMail = False;
extern bool PlaySounds = true;
extern string note7 = "SignalSoundFiles (must be in";
extern string note8 = "MetaTrader4\sounds\ directory and";
extern string note9 = "have extension .wav)";
extern string LongSignalSoundFile = "email.wav";
extern string ShortSignalSoundFile = "email.wav";
extern int    RepeatSountTimes = 1;

double alertBar;
double sarUp[],sarDn[]; //buffers
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW,STYLE_DOT);
   SetIndexStyle(1,DRAW_ARROW,STYLE_DOT);
   SetIndexBuffer(0,sarUp);
   SetIndexBuffer(1,sarDn);
   SetIndexArrow(0,115);
   SetIndexArrow(1,115);
   
   IndicatorShortName("SAR COLORED");
   SetIndexLabel(0,"PSAR Up Channel");
   SetIndexLabel(1,"PSAR Down Channel");
   
   SetIndexDrawBegin(0,2);
   SetIndexDrawBegin(1,2);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   // delete all drawn objects on deinitialisation
   ObjectsDeleteAll();   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) counted_bars=0;
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- 
  for(int i = 0; i<limit ;i++)
   {
      double sar = NormalizeDouble(iSAR(Symbol(),0,Step,Maximum,i),Precision);
      if(sar >= iHigh(Symbol(),0,i))
      {
       if (i==0 &&(SignalsEnabled) && (sarUp[1] == 0) && (Bars>alertBar))
        {
        if (PlaySounds)	for(int soundrepeats=0; soundrepeats < RepeatSountTimes; soundrepeats++) { PlaySound(ShortSignalSoundFile); Comment(soundrepeats); }
        if (Alerts) Alert("PSAR short signal on ", Symbol(),": ",Close[0]," (TF ",Period(),")");
        if (SignalMail) SendMail(""+Symbol()+" PSAR falling down","Short signal: Parabolic SAR falling down on "+Symbol()+": "+Close[0]+" (Timeframe: "+Period()+")");
        alertBar = Bars;
       }
       sarUp[i] = sar;  
       sarDn[i] = 0;
      }
    else
      {
       if (i==0 && (SignalsEnabled) && (sarDn[1] == 0) && (Bars>alertBar))
        {
        if (PlaySounds)	for(int soundrepeatl=0; soundrepeatl < RepeatSountTimes; soundrepeatl++) { PlaySound(LongSignalSoundFile); Comment(soundrepeatl); }
        if (Alerts) Alert("PSAR long signal on ", Symbol(),": ",Close[0]," (TF ",Period(),")");
        if (SignalMail) SendMail(""+Symbol()+" PSAR rising up","Long signal: Parabolic SAR rising up on "+Symbol()+": "+Close[0]+" (Timeframe: "+Period()+")");

        alertBar = Bars;
        }
         sarUp[i] = 0;
         sarDn[i] = sar;
       }
   }
 //----
   return(0);
  }
//+------------------------------------------------------------------+